# $Revision: 1.18 $, $Date: 2004/08/18 00:14:09 $
#
%bcond_without	fftwl	# don't build "long" subpackages
#
%ifarch alpha ppc sparc
# sizeof(double long)==sizeof(double) on these archs
%undefine	with_fftwl
%endif
Summary:	Fast Fourier Transform library
Summary(pl):	Biblioteka z funkcjami szybkiej transformaty Fouriera
Summary(pt_BR):	biblioteca fast fourier transform
Name:		fftw3
Version:	3.0.1
Release:	4
License:	GPL
Group:		Libraries
Source0:	ftp://ftp.fftw.org/pub/fftw/fftw-%{version}.tar.gz
# Source0-md5:	76cd21ecc9a7bed6343566c473c36477
Patch0:		%{name}-info.patch
Patch1:		%{name}-link.patch
Icon:		fftw-logo-thumb.gif
URL:		http://www.fftw.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	gcc-g77
BuildRequires:	libtool
Requires:	%{name}-common = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
FFTW is a collection of fast C routines for computing the Discrete
Fourier Transform in one or more dimensions. It includes complex,
real, and parallel transforms, and can handle arbitrary array sizes
efficiently. This RPM package includes the double precision FFTW
uniprocessor and threads libraries.

%description -l pl
FFTW jest zbiorem szybkich funkcji C do obliczania dyskretnych
transformat Fouriera w jednym lub wicej wymiarach. Zawiera rwnie
zespolone, rzeczywiste oraz rwnolege transformaty i potrafi wydajnie
radzi sobie z tablicami o dowolnych rozmiarach. Ten pakiet RPM
zawiera wersje FFTW o podwjnej precyzji dla architektur
jednoprocesorowych oraz z obsug wtkw.

%description -l pt_BR
FFTW  uma coleo de rotinas rpidas em C para computar a Discrete
Fourier Transform em uma ou mais dimenses. Incluindo transformaes
complexas, reais e paralelas, tambm pode manipular vetores de tamanho
arbitrrio eficientemente. Esse pacote RPM inclui bibliotecas FFTW com
suporte a threads, normal e dupla preciso (Os arquivos de preciso
normal tem um prefixo "s").

%package devel
Summary:	Development files for fftw
Summary(pl):	Pliki programistyczne do fftw
Summary(pt_BR):	Headers e documentao do pacote FFTW
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-common-devel = %{version}-%{release}

%description devel
This package contains the files you need to develop programs using the
FFTW (fast fourier transform library).

%description devel -l pl
Ten pakiet zawiera pliki potrzebne do tworzenia programw uywajcych
biblioteki FFTW (wykonujcej szybk transformat Fouriera).

%description devel -l pt_BR
Este pacote contm documentao e headers adicionais para desenvolver
programas usando a FFTW.

%package static
Summary:	Static fftw libraries
Summary(pl):	Statyczne biblioteki fftw
Summary(pt_BR):	Bibliotecas estticas do pacote FFTW
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static fftw libraries.

%description static -l pl
Statyczne biblioteki fftw.

%description static -l pt_BR
Este pacote contm as bibliotecas estticas do pacote FFTW.

%package single
Summary:	Fast Fourier Transform library - single precision
Summary(pl):	Biblioteka z funkcjami szybkiej transformaty Fouriera - pojedynczej precyzji
Group:		Libraries
Requires:	%{name}-common = %{version}-%{release}

%description single
FFTW is a collection of fast C routines for computing the Discrete
Fourier Transform in one or more dimensions. It includes complex,
real, and parallel transforms, and can handle arbitrary array sizes
efficiently. This RPM package includes the single precision FFTW
uniprocessor and threads libraries.

%description single -l pl
FFTW jest zbiorem szybkich funkcji C do obliczania dyskretnych
transformat Fouriera w jednym lub wicej wymiarach. Zawiera rwnie
zespolone, rzeczywiste oraz rwnolege transformaty i potrafi wydajnie
radzi sobie z tablicami o dowolnych rozmiarach. Ten pakiet RPM
zawiera wersje FFTW o pojedynczej precyzji dla architektur
jednoprocesorowych oraz z obsug wtkw.

%package single-devel
Summary:	Development files for single precision fftw
Summary(pl):	Pliki programistyczne do fftw pojedynczej precyzji
Group:		Development/Libraries
Requires:	%{name}-common-devel = %{version}-%{release}
Requires:	%{name}-single = %{version}-%{release}

%description single-devel
This package contains the files you need to develop programs using the
single precision FFTW (fast fourier transform library).

%description single-devel -l pl
Ten pakiet zawiera pliki potrzebne do tworzenia programw uywajcych
biblioteki FFTW pojedynczej precyzji (wykonujcej szybk transformat
Fouriera).

%package single-static
Summary:	Static fftw single precision libraries
Summary(pl):	Statyczne biblioteki fftw pojedynczej precyzji
Group:		Development/Libraries
Requires:	%{name}-single-devel = %{version}-%{release}

%description single-static
Static fftw single precision libraries.

%description single-static -l pl
Statyczne biblioteki fftw pojedynczej precyzji.

%package long
Summary:	Fast Fourier Transform library - long double precision
Summary(pl):	Biblioteka z funkcjami szybkiej transformaty Fouriera - rozszerzonej precyzji
Group:		Libraries
Requires:	%{name}-common = %{version}-%{release}

%description long
FFTW is a collection of fast C routines for computing the Discrete
Fourier Transform in one or more dimensions. It includes complex,
real, and parallel transforms, and can handle arbitrary array sizes
efficiently. This RPM package includes the long double precision FFTW
uniprocessor and threads libraries.

%description long -l pl
FFTW jest zbiorem szybkich funkcji C do obliczania dyskretnych
transformat Fouriera w jednym lub wicej wymiarach. Zawiera rwnie
zespolone, rzeczywiste oraz rwnolege transformaty i potrafi wydajnie
radzi sobie z tablicami o dowolnych rozmiarach. Ten pakiet RPM
zawiera wersje FFTW o rozszerzonej precyzji dla architektur
jednoprocesorowych oraz z obsug wtkw.

%package long-devel
Summary:	Development files for long double precision fftw
Summary(pl):	Pliki programistyczne do fftw rozszerzonej precyzji
Group:		Development/Libraries
Requires:	%{name}-common-devel = %{version}-%{release}
Requires:	%{name}-long = %{version}-%{release}

%description long-devel
This package contains the files you need to develop programs using the
long double precision FFTW (fast fourier transform library).

%description long-devel -l pl
Ten pakiet zawiera pliki potrzebne do tworzenia programw uywajcych
biblioteki FFTW rozszerzonej precyzji (wykonujcej szybk transformat
Fouriera).

%package long-static
Summary:	Static fftw long double precision libraries
Summary(pl):	Statyczne biblioteki fftw rozszerzonej precyzji
Group:		Development/Libraries
Requires:	%{name}-long-devel = %{version}-%{release}

%description long-static
Static fftw long double precision libraries.

%description long-static -l pl
Statyczne biblioteki fftw rozszerzonej precyzji.

%package common
Summary:	Files common for all versions of fftw libraries
Summary(pl):	Pliki wsplne dla wszystkich wersji bibliotek fftw
Group:		Libraries

%description common
Files common for all versions of fftw libraries (basic documentation,
fftw-wisdom-to-conf utility).

%description common -l pl
Pliki wsplne dla wszystkich wersji bibliotek fftw (podstawowa
dokumentacja, narzdzie fftw-wisdom-to-conf).

%package common-devel
Summary:	Development files common for all versions of fftw libraries
Summary(pl):	Pliki programistyczne wsplne dla wszystkich wersji bibliotek fftw
Group:		Development/Libraries
Requires:	%{name}-common = %{version}-%{release}

%description common-devel
Development files common for all versions of fftw libraries (header
files, development documentation).

%description common-devel -l pl
Pliki programistyczne wsplne dla wszystkich wersji bibliotek fftw
(pliki nagwkowe, dokumentacja programisty).

%prep
%setup -q -n fftw-%{version}
%patch0 -p1
%patch1 -p1

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}

# prepare three trees (for single, double, long-double precision)
echo * > files.list
install -d single long-double
cp -a `cat files.list` single
cp -a `cat files.list` long-double
ln -sf . double

# MMX/SSE/etc. seem to be safe because of runtime CPU detection
for ver in single double %{?with_fftwl:long-double} ; do
	OPTS=""
	# k7,SSE,3dnow,altivec only for single
	if [ "$ver" = "single" ]; then
%ifarch i586 k6
		OPTS="--enable-3dnow"
%endif
%ifarch i686
		OPTS="--enable-sse"
%endif
%ifarch athlon
		OPTS="--enable-sse" # "--enable-k7" disabled - causes SEGV on athlons
%endif
%ifarch ppc
		OPTS="--enable-altivec"
%endif
%ifnarch i586 i686 k6 athlon ppc
		:	# keep sh happy about syntax
%endif
	fi
%ifarch i686
	# SSE2 only for double
	if [ "$ver" = "double" ]; then
		OPTS="--enable-sse2"
	fi
%endif
cd $ver
%configure \
	--enable-shared \
	--enable-threads \
	--enable-$ver \
	$OPTS \
	--%{!?debug:dis}%{?debug:en}able-debug

%{__make}

cd ..
done

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__make} install -C single \
	DESTDIR=$RPM_BUILD_ROOT

%if %{with fftwl}
%{__make} install -C long-double\
	DESTDIR=$RPM_BUILD_ROOT
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post common-devel
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%postun common-devel
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/fftw-wisdom
%attr(755,root,root) %{_libdir}/libfftw3.so.*.*.*
%attr(755,root,root) %{_libdir}/libfftw3_threads.so.*.*.*
%{_mandir}/man1/fftw-wisdom.1*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfftw3.so
%attr(755,root,root) %{_libdir}/libfftw3_threads.so
%{_libdir}/libfftw3.la
%{_libdir}/libfftw3_threads.la
%{_pkgconfigdir}/fftw3.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libfftw3.a
%{_libdir}/libfftw3_threads.a

%files single
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/fftwf-wisdom
%attr(755,root,root) %{_libdir}/libfftw3f.so.*.*.*
%attr(755,root,root) %{_libdir}/libfftw3f_threads.so.*.*.*
%{_mandir}/man1/fftwf-wisdom.1*

%files single-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfftw3f.so
%attr(755,root,root) %{_libdir}/libfftw3f_threads.so
%{_libdir}/libfftw3f.la
%{_libdir}/libfftw3f_threads.la
%{_pkgconfigdir}/fftw3f.pc

%files single-static
%defattr(644,root,root,755)
%{_libdir}/libfftw3f.a
%{_libdir}/libfftw3f_threads.a

%if %{with fftwl}
%files long
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/fftwl-wisdom
%attr(755,root,root) %{_libdir}/libfftw3l.so.*.*.*
%attr(755,root,root) %{_libdir}/libfftw3l_threads.so.*.*.*
%{_mandir}/man1/fftwl-wisdom.1*

%files long-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libfftw3l.so
%attr(755,root,root) %{_libdir}/libfftw3l_threads.so
%{_libdir}/libfftw3l.la
%{_libdir}/libfftw3l_threads.la
%{_pkgconfigdir}/fftw3l.pc

%files long-static
%defattr(644,root,root,755)
%{_libdir}/libfftw3l.a
%{_libdir}/libfftw3l_threads.a
%endif

%files common
%defattr(644,root,root,755)
%doc AUTHORS COPYRIGHT ChangeLog NEWS README TODO
%attr(755,root,root) %{_bindir}/fftw-wisdom-to-conf
%{_mandir}/man1/fftw-wisdom-to-conf.1*

%files common-devel
%defattr(644,root,root,755)
%doc doc/html doc/FAQ/fftw-faq.html
%{_includedir}/fftw3.*
%{_infodir}/fftw3.info*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: fftw3.spec,v $
Revision 1.18  2004/08/18 00:14:09  havner
- rel 4

Revision 1.17  2004/02/19 09:49:09  qboosh
- release 3

Revision 1.16  2004/02/19 08:48:07  qboosh
- disable long* on alpha and ppc too

Revision 1.15  2004/02/19 06:59:40  qboosh
- fixed undefine on sparc

Revision 1.14  2004/02/18 23:57:58  qboosh
- typo, workaround for rpm macro parsing

Revision 1.13  2004/02/18 20:20:42  qboosh
- no *-long on sparc (long double is equal double)

Revision 1.12  2004/02/18 19:38:45  qboosh
- release 2

Revision 1.11  2004/02/18 19:16:27  qboosh
- if syntax fix for some archs

Revision 1.10  2004/02/18 19:03:02  qboosh
- strict internal deps

Revision 1.9  2004/02/17 20:04:39  wiget
- typo fixed

Revision 1.8  2003/12/02 21:45:23  freetz
- BR gcc-g77

Revision 1.7  2003/07/25 23:49:03  qboosh
- clone tree and compile using separate sources to get more reliable results
- disabled --enable-k7 on athlons (SEGV)
- added link patch (link libfftw*_threads with -lfftw* -lpthread)
- separated -single* and -long-double* subpackages (and -common* for all)

Revision 1.6  2003/07/09 21:16:02  freetz
- upgraded to bugfix release 3.0.1

Revision 1.5  2003/07/08 18:26:38  blues
- "f" and some "g" letters of small fixes inpired by kloczek

Revision 1.4  2003/06/13 16:14:48  ankry
- md5

Revision 1.3  2003/05/25 05:47:23  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.2  2003/05/14 06:27:12  qboosh
- fixed

Revision 1.1  2003/05/13 22:59:30  qboosh
- saving work:
  - fftw updated to 3.0 (not simply compatible with 2.x)
  - asm optimizations enabled
  - try to package other versions of library (single nad long-double)

Revision 1.43  2003/03/25 10:31:54  trojan
- updated to 2.1.5
- added lt/ac/am macros

Revision 1.42  2003/03/20 11:48:25  trojan
- updated to 2.1.4

Revision 1.41  2003/03/20 08:09:13  misiek
- fix build

Revision 1.40  2003/03/01 22:23:50  radek
- copied install-sh and config.sub from _datadir/automake (athlon problems)

Revision 1.39  2002/11/25 14:13:02  ankry
- massive attack: no need for 755 for *.la

Revision 1.38  2002/10/24 09:21:07  kloczek
- merge translations from Conectiva.

Revision 1.37  2002/05/15 06:11:00  kloczek
- release 10.

Revision 1.36  2002/05/14 19:10:01  qboosh
- fixed typos in pl description, removed false information about single
  precision libraries from both descriptions

Revision 1.35  2002/05/13 20:28:25  filon
- correct polish desription (have not been translated correctly)
- release 9

Revision 1.34  2002/04/25 16:17:57  arturs
fixed a small typo

Revision 1.33  2002/02/22 23:28:50  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.32  2002/02/19 18:53:33  gotar
- %desc

Revision 1.31  2002/01/26 09:41:37  kloczek
- release 8.

Revision 1.30  2002/01/25 18:52:44  filon
- use ix86 macro

Revision 1.29  2002/01/18 02:12:56  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.28  2001/08/19 16:58:30  kloczek
- spec adapterized.

Revision 1.27  2001/08/11 16:04:04  blues
- Release 7
- configure2_13
NOTE: there is possibility to turn-on fortran support

Revision 1.26  2001/07/26 05:42:07  saq
- reverting last change: removing new macros from %p{re,ost}{,un}

Revision 1.24  2001/05/10 14:24:12  baggins
- release 6
- --enable-type-prefix removed again ;)

Revision 1.23  2001/05/08 22:38:09  kloczek
- release 5,
- --enable-type-prefix is back,
- enable/disable debug %%{debug} conditionaly.

Revision 1.22  2001/01/27 22:40:47  kloczek
- release 4: added Summary(pl).

Revision 1.21  2001/01/27 22:29:38  qboosh
- ldconfig in post/postun scripts

Revision 1.20  2001/01/22 06:42:13  kloczek
- release 3,
- build without --enable-type-prefix and with --disable-debug.

Revision 1.19  2000/11/12 20:11:54  kloczek
- modyfications for using neew rpm automation.

Revision 1.18  2000/06/18 23:10:28  kloczek
- release 2.

Revision 1.17  2000/06/09 07:54:40  kloczek
- more %%{__make} macros.

Revision 1.16  2000/06/09 07:22:50  kloczek
- added using %%{__make} macro.

Revision 1.15  2000/05/24 16:50:45  zagrodzki
- changed [ -x ... ] && to [ ! -x ... ] ||

Revision 1.14  2000/05/18 20:18:39  kloczek
- spec adapterized.

Revision 1.13  2000/05/01 20:11:40  zagrodzki
- removed Prereq: /usr/sbin/fix-info-dir
- fix-info-dir in %pre/post is executed only when info is already
  installed

Revision 1.12  2000/04/01 11:14:26  zagrodzki
- changed all BuildRoot definitons
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicate empty lines

Revision 1.11  2000/03/28 17:15:17  arturs
- added %description -l pl

Revision 1.10  2000/03/28 16:54:17  baggins
- translated kloczkish into english

Revision 1.9  1999/11/08 18:21:20  kloczek
- updated to 2.1.3,
- new Source url and URL.

Revision 1.8  1999/09/24 10:57:28  pius
- moved running of /usr/sbin/fix-info-dir to %%postun
- release up

Revision 1.7  1999/09/19 09:05:40  pius
- new {un}registering procedure for info pages with using
  /usr/sbin/fix-info-dir,
- standarization to "* text: (link).  description" index info entries format.

Revision 1.6  1999/08/05 14:47:46  kloczek
- fix: {un}registering info pages must be in devel (not in main package).

Revision 1.5  1999/08/05 14:17:27  kloczek
- reorder in header.

Revision 1.4  1999/08/05 14:15:50  kloczek
- fix: added missing $RPM_BUILD_ROOT in %install,
- added info patch with adding fftw to info index,
- added "Prereq: /sbin/install-info" rule,
- added {un}registering fftw info page in %post, %preun.

Revision 1.3  1999/08/03 23:34:46  kloczek
- added gzipping info pages.

Revision 1.2  1999/08/03 23:32:48  kloczek
- completly rewrited in PLD style (compiles now).

* Tue Aug 03  1999 Dax Kelson <dax@gurulabs.com>
- Set prefix to /usr so there is no need to futz with ldconfig
